#define WIN32_MEAN_AND_LEAN
#include <windows.h>
#include "resource.h"

extern "C" RIPEMD128(LPCSTR input, unsigned int length, LPBYTE hash);
extern "C" llmul(__int64 A, __int64 B);

union i64union {
   unsigned __int64  i64;
   BYTE   byt[sizeof(__int64)];
} i64temp;

void FillSerial(LPBYTE array, int offset, __int64 var, int varlen) {
   int i;
   i64temp.i64 = var;
   for (i=0; i<varlen; i++)
      array[offset+i] = i64temp.byt[varlen-i-1];
}

void Hex2Ascii(LPBYTE instring, unsigned int len, LPBYTE outstring) {
   unsigned char temp;
   for (unsigned int i=0; i<len; i++) {
      temp = instring[i] >> 4;
      outstring[i*2]  = temp < 10? temp + '0' : temp + '7';
      temp = instring[i] & 0x0f;
      outstring[i*2+1]= temp < 10? temp + '0' : temp + '7';
   }
   outstring[i*2]=0;
}

BOOL CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam) {
   char username[65];
   BYTE name_hash[16];
   BYTE hexserial[32]="";
   char serial[65]="";
   BYTE r[7]; //roots array
   BYTE i,j,k,l,m,n;
   unsigned __int64 magic1=0,magic2=0,magic3=0,magic4=0,magic5=0,magic6=0,magic7=1;

   switch(uMsg) {
      case WM_INITDIALOG:
         SetWindowText(hDlg,"rwcm2kg");  // have to set it manually!
         break;
      case WM_COMMAND:
         switch(LOWORD(wParam)) {
            case IDCLOSE:
               EndDialog(hDlg,0);
               break;
            case IDABOUT:
               MessageBox(hDlg,"ReWolf Crackme 2.0-2.1 Keygen\n\r by Kreet","About",32);
               break;
            case IDGENERATE:
               GetDlgItemText(hDlg,IDT_NAME,username,64);
               RIPEMD128(username,lstrlen(username),name_hash);
               for(i=0; i<14; i+=2) {
                  name_hash[i] >>= 1;
                  r[i/2]=name_hash[i];
               }
               for(i=1; i<14; i+=2) name_hash[i] = 0;

               for (i=0;   i<7; i++)
                  magic1+= r[i];
               for (i=0;   i<6; i++)
               for (j=i+1; j<7; j++)
                  magic2 += r[i]*r[j];
               for (i=0;   i<5; i++)
               for (j=i+1; j<6; j++)
               for (k=j+1; k<7; k++)
                  magic3 += r[i]*r[j]*r[k];
               for (i=0;   i<4; i++)
               for (j=i+1; j<5; j++)
               for (k=j+1; k<6; k++)
               for (l=k+1; l<7; l++)
                  magic4 += r[i]*r[j]*r[k]*r[l];
               for (i=0;   i<3; i++)
               for (j=i+1; j<4; j++)
               for (k=j+1; k<5; k++)
               for (l=k+1; l<6; l++)
               for (m=l+1; m<7; m++)
                  magic5 += (__int64)r[i]*(__int64)r[j]*(__int64)r[k]*(__int64)r[l]*(__int64)r[m];
               for (i=0;   i<2; i++)
               for (j=i+1; j<3; j++)
               for (k=j+1; k<4; k++)
               for (l=k+1; l<5; l++)
               for (m=l+1; m<6; m++)
               for (n=m+1; n<7; n++)
                  magic6 += (__int64)r[i]*(__int64)r[j]*(__int64)r[k]*(__int64)r[l]*(__int64)r[m]*(__int64)r[n];
               for (i=0; i<7; i++)
                  magic7 *= (__int64)r[i];

               //serial format: 2 3 4 5 5 6 7
               //so offsets go 0,2,5,9,14,19,25
               FillSerial(hexserial, 0,magic1,2);
               FillSerial(hexserial, 2,magic2,3);
               FillSerial(hexserial, 5,magic3,4);
               FillSerial(hexserial, 9,magic4,5);
               FillSerial(hexserial,14,magic5,5);
               FillSerial(hexserial,19,magic6,6);
               FillSerial(hexserial,25,magic7,7);

               Hex2Ascii(hexserial,32,(LPBYTE)serial);
               j=17;
               i=0;
               do {  //scramble serial
                  serial[i++]+=j++;
                  if(j == 21) j = 17;
               } while (i < 64);
               SetDlgItemText(hDlg,IDT_SERIAL,serial);
               break;
         }
         break;
      case WM_MOUSEMOVE:
         if(wParam==1) {
            ReleaseCapture();
            SendMessage(hDlg,WM_SYSCOMMAND,0xf012,0);
         }
         break;
      case WM_CLOSE:
         EndDialog(hDlg,0);
         break;
      default:
         return FALSE;
   }
   return TRUE;
}

int main(void) {
   return (int) DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProc,NULL);
}